jjb: babeltrace cleanups
[lttng-ci.git] / scripts / liburcu / build.sh
index 8e5a9c611d272c50f2ddc5594bd97debde45a7e1..8a699ea92bcd4691d37c1b68abd45b328fbb50dc 100755 (executable)
@@ -1,6 +1,7 @@
-#!/bin/sh -exu
+#!/bin/bash -exu
 #
 # Copyright (C) 2015 - Jonathan Rajotte-Julien <jonathan.rajotte-julien@efficios.com>
+#               2016 - Michael Jeanson <mjeanson@efficios.com>
 #
 # This program is free software: you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
 # You should have received a copy of the GNU General Public License
 # along with this program.  If not, see <http://www.gnu.org/licenses/>.
 
-
-# Create build directory
-rm -rf $WORKSPACE/build
-mkdir -p $WORKSPACE/build
-
+# Version compare functions
+vercomp () {
+    set +u
+    if [[ "$1" == "$2" ]]; then
+        return 0
+    fi
+    local IFS=.
+    local i ver1=($1) ver2=($2)
+    # fill empty fields in ver1 with zeros
+    for ((i=${#ver1[@]}; i<${#ver2[@]}; i++)); do
+        ver1[i]=0
+    done
+    for ((i=0; i<${#ver1[@]}; i++)); do
+        if [[ -z ${ver2[i]} ]]; then
+            # fill empty fields in ver2 with zeros
+            ver2[i]=0
+        fi
+        if ((10#${ver1[i]} > 10#${ver2[i]})); then
+            return 1
+        fi
+        if ((10#${ver1[i]} < 10#${ver2[i]})); then
+            return 2
+        fi
+    done
+    set -u
+    return 0
+}
+
+verlte() {
+    vercomp "$1" "$2"; local res="$?"
+    [ "$res" -eq "0" ] || [ "$res" -eq "2" ]
+}
+
+verlt() {
+    vercomp "$1" "$2"; local res="$?"
+    [ "$res" -eq "2" ]
+}
+
+vergte() {
+    vercomp "$1" "$2"; local res="$?"
+    [ "$res" -eq "0" ] || [ "$res" -eq "1" ]
+}
+
+vergt() {
+    vercomp "$1" "$2"; local res="$?"
+    [ "$res" -eq "1" ]
+}
+
+verne() {
+    vercomp "$1" "$2"; local res="$?"
+    [ "$res" -ne "0" ]
+}
+
+
+SRCDIR="$WORKSPACE/src/liburcu"
+TMPDIR="$WORKSPACE/tmp"
 PREFIX="$WORKSPACE/build"
 
-./bootstrap
+# Create build and tmp directories
+rm -rf "$PREFIX" "$TMPDIR"
+mkdir -p "$PREFIX" "$TMPDIR"
 
-CONF_OPTS=""
+export TMPDIR
 
+# Set platform variables
 case "$arch" in
 solaris10)
     MAKE=gmake
@@ -33,6 +88,7 @@ solaris10)
     NPROC=gnproc
     CFLAGS="-D_XOPEN_SOURCE=1 -D_XOPEN_SOURCE_EXTENDED=1 -D__EXTENSIONS__=1"
     ;;
+
 solaris11)
     MAKE=gmake
     TAR=gtar
@@ -40,6 +96,18 @@ solaris11)
     CFLAGS="-D_XOPEN_SOURCE=1 -D_XOPEN_SOURCE_EXTENDED=1 -D__EXTENSIONS__=1"
     export PATH="$PATH:/usr/perl5/bin"
     ;;
+
+macosx)
+    MAKE=make
+    TAR=tar
+    NPROC="getconf _NPROCESSORS_ONLN"
+    BISON="bison"
+    YACC="$BISON -y"
+    export PATH="/opt/local/bin:/opt/local/sbin:/usr/local/bin:/usr/bin:/bin:/usr/sbin:/sbin"
+    export CFLAGS="-I/opt/local/include"
+    export LDFLAGS="-L/opt/local/lib"
+    ;;
+
 *)
     MAKE=make
     TAR=tar
@@ -48,21 +116,36 @@ solaris11)
     ;;
 esac
 
+# Set configure options for each build configuration
+CONF_OPTS=""
 case "$conf" in
 static)
     echo "Static build"
     CONF_OPTS="--enable-static --disable-shared"
     ;;
+
 tls_fallback)  
     echo  "Using pthread_getspecific() to emulate TLS"
     CONF_OPTS="--disable-compiler-tls"
     ;;
+
 *)
     echo "Standard build"
     CONF_OPTS=""
     ;;
 esac
 
+
+# Enter the source directory
+cd "$SRCDIR"
+
+# Run bootstrap in the source directory prior to configure
+./bootstrap
+
+# Get source version from configure script
+eval `grep '^PACKAGE_VERSION=' ./configure`
+
+
 # Build type
 # oot : out-of-tree build
 # dist: build via make dist
@@ -70,54 +153,64 @@ esac
 #
 # Make sure to move to the build_path and configure
 # before continuing
-
-BUILD_PATH=$WORKSPACE
+BUILD_PATH=$SRCDIR
 case "$build" in
-       oot)
-               echo "Out of tree build"
-               BUILD_PATH=$WORKSPACE/oot
-               mkdir -p $BUILD_PATH
-               cd $BUILD_PATH
-               MAKE=$MAKE CFLAGS="$CFLAGS" $WORKSPACE/configure --prefix=$PREFIX $CONF_OPTS
-               ;;
-       dist)
-               echo "Distribution out of tree build"
-               BUILD_PATH=`mktemp -d`
-
-               # Initial configure and generate tarball
-               MAKE=$MAKE ./configure
-               $MAKE dist
-
-               mkdir -p $BUILD_PATH
-               cp *.tar.* $BUILD_PATH/
-               cd $BUILD_PATH
-
-               # Ignore level 1 of tar
-               $TAR xvf *.tar.* --strip 1
-
-               MAKE=$MAKE CFLAGS="$CFLAGS" $BUILD_PATH/configure --prefix=$PREFIX $CONF_OPTS
-               ;;
-       *)
-               BUILD_PATH=$WORKSPACE
-               echo "Standard tree build"
-               MAKE=$MAKE CFLAGS="$CFLAGS" $WORKSPACE/configure --prefix=$PREFIX $CONF_OPTS
-               ;;
+oot)
+    echo "Out of tree build"
+    BUILD_PATH=$WORKSPACE/oot
+    mkdir -p "$BUILD_PATH"
+    cd "$BUILD_PATH"
+    MAKE=$MAKE CFLAGS="$CFLAGS" "$SRCDIR/configure" --prefix="$PREFIX" $CONF_OPTS
+    ;;
+
+dist)
+    echo "Distribution out of tree build"
+    BUILD_PATH=`mktemp -d`
+
+    # Initial configure and generate tarball
+    MAKE=$MAKE "$SRCDIR/configure"
+    $MAKE dist
+
+    mkdir -p "$BUILD_PATH"
+    cp ./*.tar.* "$BUILD_PATH/"
+    cd "$BUILD_PATH"
+
+    # Ignore level 1 of tar
+    $TAR xvf ./*.tar.* --strip 1
+
+    MAKE=$MAKE CFLAGS="$CFLAGS" "$BUILD_PATH/configure" --prefix="$PREFIX" $CONF_OPTS
+    ;;
+*)
+    echo "Standard in-tree build"
+    MAKE=$MAKE CFLAGS="$CFLAGS" "$BUILD_PATH/configure" --prefix="$PREFIX" $CONF_OPTS
+    ;;
 esac
 
-$MAKE -j `$NPROC`
+# BUILD!
+$MAKE -j `$NPROC` V=1
 $MAKE install
+
+# Run tests
 $MAKE check
-$MAKE regtest
+# Only run regtest for 0.9 and up
+if vergte "$PACKAGE_VERSION" "0.9"; then
+   $MAKE regtest
+fi
+
+# Cleanup
 $MAKE clean
 
-# Cleanup rpath and libtool .la files
-find $WORKSPACE/build/lib -name "*.so" -exec chrpath --delete {} \;
-find $WORKSPACE/build/lib -name "*.la" -exec rm -f {} \;
+# Cleanup rpath in executables and shared libraries
+#find $WORKSPACE/build/bin -type f -perm -0500 -exec chrpath --delete {} \;
+find "$PREFIX/lib" -name "*.so" -exec chrpath --delete {} \;
+
+# Remove libtool .la files
+find "$PREFIX/lib" -name "*.la" -exec rm -f {} \;
 
 # Cleanup temp directory of dist build
-if [ $build = "dist" ]; then
-       cd $WORKSPACE
-       rm -rf $BUILD_PATH
+if [ "$build" = "dist" ]; then
+    cd "$SRCDIR"
+    rm -rf "$BUILD_PATH"
 fi
 
 # EOF
This page took 0.024776 seconds and 4 git commands to generate.